config/routes.rb
Rails.application.routes.draw do
  devise_for :admins
  root 'welcome#index'
  resources :medics
  resources :offices
  resources :turns
  resources :patients

end

app/models/admin.rb
class Admin < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/models/medic.rb
class Medic < ActiveRecord::Base
  belongs_to :office
  has_many :turns
  validates :license_number, uniqueness: true

end

app/models/office.rb
class Office < ActiveRecord::Base
  has_one :medic
  validates :number, uniqueness: true

end

app/models/patient.rb
class Patient < ActiveRecord::Base
  has_many :turns
  validates :mail, uniqueness: true
  validates :dni, uniqueness: true
end

app/models/turn.rb
class Turn < ActiveRecord::Base
  belongs_to :medic
  belongs_to :patient
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
  before_action :authenticate_admin!

end

app/controllers/medics_controller.rb
class MedicsController < ApplicationController
  before_action :set_medic, only: [:show, :edit, :update, :destroy]

  # GET /medics
  # GET /medics.json
  def index
    @medics = Medic.all
  end

  # GET /medics/1
  # GET /medics/1.json
  def show
  end

  # GET /medics/new
  def new
    @medic = Medic.new
  end

  # GET /medics/1/edit
  def edit
  end

  # POST /medics
  # POST /medics.json
  def create
    @medic = Medic.new(medic_params)

    respond_to do |format|
      if @medic.save
        format.html { redirect_to @medic, notice: 'Medic was successfully created.' }
        format.json { render :show, status: :created, location: @medic }
      else
        format.html { render :new }
        format.json { render json: @medic.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /medics/1
  # PATCH/PUT /medics/1.json
  def update
    respond_to do |format|
      if @medic.update(medic_params)
        format.html { redirect_to @medic, notice: 'Medic was successfully updated.' }
        format.json { render :show, status: :ok, location: @medic }
      else
        format.html { render :edit }
        format.json { render json: @medic.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /medics/1
  # DELETE /medics/1.json
  def destroy
    @medic.destroy
    respond_to do |format|
      format.html { redirect_to medics_url, notice: 'Medic was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_medic
      @medic = Medic.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def medic_params
      params.require(:medic).permit(:name, :surname, :license_number, :specialization, :office_id)
    end
end

app/controllers/offices_controller.rb
class OfficesController < ApplicationController
  before_action :set_office, only: [:show, :edit, :update, :destroy]

  # GET /offices
  # GET /offices.json
  def index
    @offices = Office.all
  end

  # GET /offices/1
  # GET /offices/1.json
  def show
  end

  # GET /offices/new
  def new
    @office = Office.new
  end

  # GET /offices/1/edit
  def edit
  end

  # POST /offices
  # POST /offices.json
  def create
    @office = Office.new(office_params)

    respond_to do |format|
      if @office.save
        format.html { redirect_to @office, notice: 'Office was successfully created.' }
        format.json { render :show, status: :created, location: @office }
      else
        format.html { render :new }
        format.json { render json: @office.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /offices/1
  # PATCH/PUT /offices/1.json
  def update
    respond_to do |format|
      if @office.update(office_params)
        format.html { redirect_to @office, notice: 'Office was successfully updated.' }
        format.json { render :show, status: :ok, location: @office }
      else
        format.html { render :edit }
        format.json { render json: @office.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /offices/1
  # DELETE /offices/1.json
  def destroy
    @office.destroy
    respond_to do |format|
      format.html { redirect_to offices_url, notice: 'Office was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_office
      @office = Office.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def office_params
      params.require(:office).permit(:number)
    end
end

app/controllers/patients_controller.rb
class PatientsController < ApplicationController
    def index
      @patients = Patient.all
    end

    def show
      @patient = Patient.find(params[:id])
    end

    def new
      @patient = Patient.new
    end
    def create
      @patient = Patient.new(patient_params)
      if @patient.save
        redirect_to(:action => 'index')
      else
        render('new')
      end
    end

    def edit
      @patient = Patient.find(params[:id])
    end
    def update
      @patient = Patient.find(params[:id])
      if @patient.update_attributes(patient_params)
        redirect_to(:action => 'show', :id => @patient.id)
      else
        render ('edit')
      end
    end

    def delete
      @patient = Patient.find(params[:id])
    end
    def destroy
      Patient.find(params[:id]).destroy
      redirect_to(:action => 'index')
    end
    private
    def patient_params
      params.require(:patient).permit(:name,:surname,:dni,:age,:mail,:password)
    end
end

app/controllers/turns_controller.rb
class TurnsController < ApplicationController
  before_action :set_turn, only: [:show, :edit, :update, :destroy]


  def index
    @turns = Turn.all
    respond_to do |format|
      format.html
      format.json {
        events []
        @turns.each do |turn|
          events << {:id => turn.id, :title => "#{turn.patient_id}", :start => "#{turn.date}"}
        end
        render :text => events.to_json
      }
    end
  end

  def show
  end

  def new
    @turn = Turn.new
    @patients = Patient.all
  end

  def edit
  end

  def create
    @turn = Turn.new(turn_params)

    respond_to do |format|
      if @turn.save
        format.html { redirect_to @turn, notice: 'Turn was successfully created.' }
        format.json { render :show, status: :created, location: @turn }
      else
        format.html { render :new }
        format.json { render json: @turn.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    respond_to do |format|
      if @turn.update(turn_params)
        format.html { redirect_to @turn, notice: 'Turn was successfully updated.' }
        format.json { render :show, status: :ok, location: @turn }
      else
        format.html { render :edit }
        format.json { render json: @turn.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /turns/1
  # DELETE /turns/1.json
  def destroy
    @turn.destroy
    respond_to do |format|
      format.html { redirect_to turns_url, notice: 'Turn was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_turn
      @turn = Turn.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def turn_params
      params.require(:turn).permit(:date, :patient_id, :medic_id)
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/medics_helper.rb
module MedicsHelper
end

app/helpers/offices_helper.rb
module OfficesHelper
end

app/helpers/patients_helper.rb
module PatientsHelper
end

app/helpers/turns_helper.rb
module TurnsHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>TPFinal</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
  <%= csrf_meta_tags %>
</head>
<body>
<ul id="dropdown1" class="dropdown-content">
  <li><%= link_to 'Edit profile', edit_admin_registration_path %></li>
  <li class="divider"></li>
  <li><%= link_to "Logout", destroy_admin_session_path, method: :delete%></li>
</ul>

<nav>
  <div class="nav-wrapper">
    <a href="/" class="brand-logo center">Example Clinic</a>
    <ul id="nav-mobile" class="left hide-on-med-and-down">
      <li><%= link_to 'Medics', medics_path %></li>
      <li><%= link_to 'Patients', patients_path %></li>
      <li><%= link_to 'Turns', turns_path %></li>
      <li><%= link_to 'Offices', offices_path %></li>
    </ul>
    <ul id="nav-mobile" class="right hide-on-med-and-down">
      <li><% if admin_signed_in? %>
          <li><a class="dropdown-button" href="#" data-activates="dropdown1">Logged in as <strong><%= current_admin.email %></strong><i class="material-icons right">arrow_drop_down</i></a></li>
        <% else %>
          <li><%= link_to "Sign up", new_admin_registration_path, :class => 'navbar-link'  %></li>
          <li> <%= link_to "Login", new_admin_session_path, :class => 'navbar-link'  %></li>
        <% end %>
      </li>
    </ul>
  </div>
</nav>
<% if notice %>
    <p class="alert alert-success"><%= notice %></p>
<% end %>
<% if alert %>
    <p class="alert alert-danger"><%= alert %></p>
<% end %>
<div class="row">
  <div class="col s12">
<%= yield %>
    </div>
</div>
</body>
<script type="text/javascript" charset="utf-8">
    $( document ).ready(function()
    {
        $(".dropdown-button").dropdown();
    });
</script>
</html>

app/views/medics/_form.html.erb
<%= form_for(@medic) do |f| %>
  <% if @medic.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@medic.errors.count, "error") %> prohibited this medic from being saved:</h2>

      <ul>
      <% @medic.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name , :maxlength => 30, :required => true %>

  </div>
  <div class="field">
    <%= f.label :surname %><br>
    <%= f.text_field :surname, :maxlength => 30, :required => true %>

  </div>
  <div class="field">
    <%= f.label :license_number %><br>
    <%= f.number_field :license_number, :maxlength => 30, :required => true %>

  </div>
  <div class="field">
    <%= f.label :specialization %><br>
    <%= f.text_field :specialization, :maxlength => 30, :required => true %>

  </div>
    <%= f.label :office %>
    <%= f.collection_select(:office_id, Office.all, :id, :number) %>
    <br><br>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>
<script>
    $(document).ready(function() {
        $('select').material_select();
    });
</script>

app/views/medics/edit.html.erb
<h1>Editing Medic</h1>

<%= render 'form' %>

<%= link_to 'Show', @medic %> |
<%= link_to 'Back', medics_path %>

app/views/medics/index.html.erb
<h4 class="center-align">Listing Medics</h4>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Surname</th>
      <th>License number</th>
      <th>Specialization</th>
      <th>Office</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @medics.each do |medic| %>
      <tr>
        <td><%= medic.name %></td>
        <td><%= medic.surname %></td>
        <td><%= medic.license_number %></td>
        <td><%= medic.specialization %></td>
        <td><%= medic.office.number %></td>
        <td><%= link_to 'Show', medic %></td>
        <td><%= link_to 'Edit', edit_medic_path(medic) %></td>
        <td><%= link_to 'Destroy', medic, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Medic', new_medic_path %>

app/views/medics/new.html.erb
<h1>New Medic</h1>

<%= render 'form' %>

<%= link_to 'Back', medics_path %>

app/views/medics/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @medic.name %>
</p>

<p>
  <strong>Surname:</strong>
  <%= @medic.surname %>
</p>

<p>
  <strong>License number:</strong>
  <%= @medic.license_number %>
</p>

<p>
  <strong>Specialization:</strong>
  <%= @medic.specialization %>
</p>

<p>
  <strong>Office:</strong>
  <%= @medic.office.number %>
</p>
<%= link_to 'Edit', edit_medic_path(@medic) %> |
<%= link_to 'Back', medics_path %>

app/views/offices/_form.html.erb
<%= form_for(@office) do |f| %>
  <% if @office.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@office.errors.count, "error") %> prohibited this office from being saved:</h2>

      <ul>
      <% @office.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

    <div class="field">
      <%= f.text_field :number %>
      <%= f.label :number, :maxlength => 30, :required => true %><br>
    </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/offices/edit.html.erb
<h1>Editing Office</h1>

<%= render 'form' %>

<%= link_to 'Show', @office %> |
<%= link_to 'Back', offices_path %>

app/views/offices/index.html.erb
<h1>Listing Offices</h1>

<table>
  <thead>
    <tr>
      <th>Number</th>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @offices.each do |office| %>
      <tr>
        <td> <%= office.number %> </td>
        <td><%= link_to 'Edit', edit_office_path(office) %></td>
        <td><%= link_to 'Destroy', office, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Office', new_office_path %>

app/views/offices/new.html.erb
<h1>New Office</h1>

<%= render 'form' %>

<%= link_to 'Back', offices_path %>

app/views/patients/_form.html.erb
<%= form_for(@patient) do |f| %>
    <% if @patient.errors.any? %>
        <div id="error_explanation">
          <h2><%= pluralize(@patient.errors.count, "error") %> prohibited this user from being saved:</h2>

          <ul>
            <% @patient.errors.full_messages.each do |message| %>
                <li><%= message %></li>
            <% end %>
          </ul>
        </div>
    <% end %>
    <div class="actions">
    <%= f.label :Nombre%>
    <%= f.text_field :name, :maxlength => 30, :required => true %><br><br>

    <%= f.label :Apellido%>
    <%= f.text_field :surname, :maxlength => 30, :required => true %><br><br>

    <%= f.label :edad %>
    <%= f.number_field :age, :maxlength => 30, :required => true %><br><br>

    <%= f.label :dni %>
    <%= f.number_field :dni, :maxlength => 30, :required => true%><br><br>

    <%= f.label :Mail %>
    <%= f.email_field :mail%><br><br>


    <%= f.submit "Guardar" %>
  </div>
<% end %>

app/views/patients/edit.html.erb
<h1>Editing Patient</h1>

<%= render 'form' %>

<%= link_to 'Show', @patient %> |
<%= link_to 'Back', patients_path %>

app/views/patients/index.html.erb
<h4 class="center-align">Listing Patients</h4>

<table>
  <thead>
    <tr>
      <th>Nombre</th>
      <th>Apellido</th>
      <th>Edad</th>
      <th>Dni</th>
      <th>Mail</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @patients.each do |patient| %>
      <tr>
        <td><%= patient.name %></td>
        <td><%= patient.surname %></td>
        <td><%= patient.age %></td>
        <td><%= patient.dni %></td>
        <td><%= patient.mail %></td>
        <td><%= link_to 'Show', patient %></td>
        <td><%= link_to 'Edit', edit_patient_path(patient) %></td>
        <td><%= link_to 'Destroy', patient, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Patient', new_patient_path %>

app/views/patients/new.html.erb
<p id="notice"><%= notice %></p>

<h1>Nuevo Paciente</h1>

<%= render 'form' %>

<%= link_to 'Back', patients_path %>

app/views/patients/show.html.erb
<p id="notice"><%= notice %></p>
<h1><%= @patient.surname %> <%= @patient.name %></h1>
<b>DNI:</b> <%= @patient.dni%> <br>
<b>MAIL: </b><%= @patient.mail %><br>
<b>AGE:</b> <%= @patient.age %><br>

<%= link_to 'Editar', edit_patient_path(@patient) %> |
<%= link_to 'Atras', patients_path %>

app/views/turns/_form.html.erb
<%= form_for(@turn, :html => {:class => 'col s12'}) do |f| %>
  <% if @turn.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@turn.errors.count, "error") %> prohibited this turn from being saved:</h2>

      <ul>
      <% @turn.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
    <div class="row">
      <div class="row">
        <div class="input-field col s1">
          <%= f.datetime_select :date %>
          <%= f.label :Dia_y_hora %>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s2">
            <%= f.collection_select(:patient_id, Patient.all, :id, :dni) %>
            <%= f.label :Dni_paciente%>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s2">
            <%= f.collection_select(:medic_id, Medic.all, :id, :license_number) %>
            <%= f.label :Licencia_medico%>
        </div>
      </div>
    <%= f.submit %>
    </div>

<% end %>
<script>
$(document).ready(function() {
$('select').material_select();
});
</script>

app/views/turns/edit.html.erb
<h1>Editing Turn</h1>

<%= render 'form' %>

<%= link_to 'Show', @turn %> |
<%= link_to 'Back', turns_path %>

app/views/turns/index.html.erb
<h4 class="center-align">Listing Turns</h4>

<div class="row center-align ">
  <a href="<%= new_turn_path %>" class="btn-floating btn-large waves-effect waves-light blue"><i class="material-icons">add</i></a>
</div>

<div id="calendar"></div>

<script type='text/javascript'>

    $(document).ready(function() {

        $('#calendar').fullCalendar({
            header: {
                left: 'prev,next today',
                center: 'title',
                right: 'month,agendaWeek,agendaDay'
            },
            defaultView: 'month',
            selectable: true,
            eventClick: function (event, jsEvent, view) {
                window.location = location.href + '/' + event.turnId;
            },
            events: [
            <% @turns.each do |turn| %>
            {
                title  : '<%= turn.patient.name + " " + turn.patient.surname %>',
                start  : '<%= turn.date.to_formatted_s(:iso8601) %>',
                turnId : '<%= turn.id %>'

            },
            <% end %>
        ]
        });

    });

</script>
<style type='text/css'>
    #calendar {
        width: 900px;
        margin: 0 auto;
    }

</style>

app/views/turns/new.html.erb
<h1>New Turn</h1>

<%= render 'form' %>

<%= link_to 'Back', turns_path %>

app/views/turns/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Date:</strong> <%= @turn.date %><br><br>
  <strong>Patient name: </strong><%= @turn.patient.name %><br><br>
  <strong>Medic Name: </strong><%= @turn.medic.name %><br><br>
</p>

<%= link_to 'Destroy', @turn, method: :delete, data: { confirm: 'Are you sure?' } %> |
<%= link_to 'Edit', edit_turn_path(@turn) %> |
<%= link_to 'Back', turns_path %>

app/views/welcome/index.html.erb
<h5 class="center-align">Administration control panel</h5>